package com.christopherdro.RNPrint;

import android.os.Bundle;
import android.os.CancellationSignal;
import android.os.ParcelFileDescriptor;
import android.print.PageRange;
import android.print.PrintAttributes;
import android.print.PrintDocumentAdapter;

public class RNPrintAdapterWrapper extends PrintDocumentAdapter {
	private final RNPrintListener listener;
	private final PrintDocumentAdapter delegate;

	public RNPrintAdapterWrapper(PrintDocumentAdapter adapter, RNPrintListener listener){
		this.listener = listener;
		this.delegate = adapter;
	}

	@Override
	public void onLayout(PrintAttributes oldAttributes, PrintAttributes newAttributes, CancellationSignal cancellationSignal, LayoutResultCallback callback, Bundle extras) {
		delegate.onLayout(oldAttributes, newAttributes, cancellationSignal, callback, extras);
	}

	@Override
	public void onWrite(PageRange[] pages, ParcelFileDescriptor destination, CancellationSignal cancellationSignal, WriteResultCallback callback) {
		delegate.onWrite(pages, destination, cancellationSignal, callback);
	}

	@Override
	public void onFinish(){
		delegate.onFinish();
		if(listener != null){
			listener.onFinish();
		}
	}

	@Override
	public void onStart() {
		delegate.onStart();
		if(listener != null){
			listener.onStart();
		}
	}
}